//import {feature} from 'topojson'; //potrebujem transformovat topojson na geojson s kt. pracuje d3.js
import {csv,range,timeParse} from 'd3';
const allCaps =str=>str==str.toUpperCase();//vyfiltrovat kontinenty
const isRegion =name=> allCaps(name) && name!='WORLD';
export  const parseYear=timeParse('%Y');
const melt =(unData,minYear,maxYear)=>{
		
   const years=range(minYear,maxYear+1);
        const data=[]; //empty array
        
    //ideme robit melting - table with multiple columns (icecube) melt into 3 columns - (icle)
        unData.forEach(d=>{
          	const country=d['Region, subregion, country or area *']
                  .replace('AND THE','&');
                years.forEach(year =>{
                 const population=+d[year].replace(/ /g,'')*1000;
                 const row={//konstruujeme novy object
                      year:parseYear(year),
                      country,
                      population
                 };
                data.push(row); 
             });
        });
    
    return data.filter(d => isRegion(d.country));
};

export const loadAndProcessData=()=>
  Promise.all([// for coupling premises into one scope
         csv('https://vizhub.com/curran/datasets/un-population-estimates-2017-medium-variant.csv'),
         csv('https://vizhub.com/curran/datasets/un-population-estimates-2017.csv')
        ]).then(([unDataMediumVariant,unDataEstimates])=>{
       
           //return melt(unDataMediumVariant,2015,2100);
           return melt(unDataEstimates,1950,2014)
              .concat(melt(unDataMediumVariant,2015,2100));
/*

          const rowById=unData.reduce((accumulator,d)=>{
            // accumulator[d.iso_n3]=d.name;//iba name
            accumulator[d['Country code']]=d;//vsetko
             return accumulator;
          }, {});

       const countries = feature(topoJSONdata,topoJSONdata.objects.countries);
           countries.features.forEach(d=>{// urobime preprocesing, aby sme nemuseli robit lookup neskor
              Object.assign(d.properties,rowById[+d.id]);//namiesto rowById[].name budeme vola d.name...
            

          });
       const featureWithPopulation=countries.features
         .filter(d=>d.properties['2018'])
         .map(d=> {
          d.properties['2018'] = +d.properties['2018'].replace(/ /g,'')*1000;
          return d;
         });
    console.log(countries);
    return {
      features:countries.features,
      featureWithPopulation
    };
   */
  });